/***************************************************************************
                          sglwindow.h  -  description
                             -------------------
    begin                : Wed Jan 23 2002
    copyright            : (C) 2002 by Andre Stein
    email                : andre_stein@web.de
    url                  : www.steinsoft.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SGLWINDOW_H
#define SGLWINDOW_H

#include <GL/gl.h> 
#include <GL/glu.h>
#include "sropewave.h"
#include "swaterwave.h"

//inital mouse position
#define INIT_MOUSE_X 320
#define INIT_MOUSE_Y 240

/**
  *@author Andre Stein
  */

class SGLWindow
{
public: 
	SGLWindow();
	~SGLWindow();
	
	void resize(int width, int height);
	void init();
	void update(float frametime);
 	void keyDown(int key);
protected:
	SRopeWave rope;
	SWaterWave water;
	bool showWater;

	void handleMouse();
};

#endif
