/***************************************************************************
 *   Copyright (C) 2003 by Andr Stein                                     *
 *   stone@steinsoft.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef SROPEWAVE_H
#define SROPEWAVE_H

#include <math.h>

struct sWave
{
	sWave() 
	:amplitude(0), T(0), lambda(0), time(0)
	{	
	}
	
	float amplitude;
	float T;
	float lambda;
	float time;
	
	void setSpeed (float c) { T = lambda/c; }
	
	//return y(x,t) function
	float y(float x) 
	{
		// physical formula:
		//  y(x,t) = amplitude * sin ( x/lam - t/T )
		return amplitude * sin( 2*M_PI*( (time/T) - (x/lambda) ) );
	}
};

/**
@author Andr Stein
*/
class SRopeWave
{
public:
	SRopeWave();
	~SRopeWave();
	
	void update(float frametime);
protected:
	sWave wave;

	void draw();
};

#endif
